#
#    Copyright (c) 2009 Tom Keffer <tkeffer@gmail.com>
#
#    See the file LICENSE.txt for your full rights.
#
"""Create NOAA monthly summary files.

"""

import time
import os.path
import weeutil.weeutil

class NOAA(object):
    
    def __init__(self, archive, noaa_dir):
        
        self.archive = archive
        self.noaa_dir = noaa_dir
        
    def genReports(self, timestamp):
        
        start_ts = self.archive.firstGoodStamp()
        
        for (month_start_ts, month_stop_ts) in weeutil.weeutil.monthRange(start_ts, timestamp):
            print month_start_ts, month_stop_ts
            
            _yr, _mo = time.localtime(month_start_ts)[0:2]
            filename = time.strftime("NOAA-%Y-%m.txt", (_yr, _mo, 1, 0, 0, 0, 0, 0, -1))
            fullpath = os.path.join(self.noaa_dir, filename)
            if not os.path.exists(fullpath) or month_start_ts < timestamp <= month_stop_ts:
                print "Need to generate %s." %(fullpath,)
                self.genMonth(month_start_ts, month_stop_ts)
                
    def genMonth(self, month_start_ts, month_stop_ts):
        now it gets hard...
            
            
if __name__ == '__main__':
    import os.path
    import configobj
    import weewx.archive
    
    def main(config_path):
        try :
            config_dict = configobj.ConfigObj(config_path, file_error=True)
        except IOError:
            print "Unable to open configuration file ", config_path
            exit()
    
        archive = weewx.archive.Archive(os.path.join(config_dict['Station']['WEEWX_ROOT'], 
                                                     config_dict['Archive']['archive_file']))
        
        noaa_dir = os.path.join(config_dict['Station']['WEEWX_ROOT'], 
                            config_dict['NOAA'].get('noaa_root', 'NOAA'))
        noaa = NOAA(archive, noaa_dir)
        noaa.genReports(archive.lastGoodStamp())
        
    
    main('../hrwx.conf')